# Non-negative property example defined in the notes.
# Here, anyone can bind the count property, but it must be bound to a
#  non-negative value.


class C:
    def __init__(self,init):
        self.count = init

    def inc(self):
        self.count += 1

    #...def other methods...

    def get_count(self):
        return self.the_count

    def set_count(self, value):
        if  value < 0:
            raise ValueError(f'C.set_count: value({value}) not >= 0')
        self.the_count = value

    def del_count(self):
        del self.the_count

    count = property(get_count, set_count, del_count)

o = C(5)
print('o = C(5)')
print('o namespace=',o.__dict__)
print('search for o.count=',o.count)

print('\no.inc()')
o.inc()
print('search for o.count=',o.count)

try:
    print('\no.count = -1')
    o.count = -1
except:
    print('Exception raised: could not rebind o.count with negative value')
print('search for o.count=',o.count)

print('\ndel o.count')
del o.count
print('o namespace=',o.__dict__)

try:
    print("\nprint('search for o.count=',o.count)")
    print('search for o.count=',o.count) 
except:
    print('Exception raised: could not compute o.count')
